      SUBROUTINE barmatter(nes,phi,phiold,p,rhobm,
     .     vx,vy,vz,nx,ny,nz,at,dat,ath,dath,dt,dtold,
     .     gamma,eta1,eta2,dmax,norm,nstep,lflow,velmax)
!     

      IMPLICIT NONE

!     
!     parameters
!     

      INTEGER(1), DIMENSION (nx,ny,nz) :: nes
      REAL*8, DIMENSION (nx,ny,nz) :: phi,phiold
      REAL*8, DIMENSION (nx,ny,nz) :: p,vx,vy,vz,rhobm
      INTEGER:: nx,ny,nz
      REAL*8 :: at,dat,ath,dath,dt,dtold,gamma
      REAL*8 :: eta1,eta2
      REAL*8 :: dmax,norm,velmax
      INTEGER:: nstep
      INTEGER, DIMENSION (3,6) :: lflow

!     
!     local variables
!     
      INTEGER:: side, lstep
!     
      INTEGER :: error      
      REAL*8, DIMENSION (:,:,:), ALLOCATABLE :: pold,rhobmold
      REAL*8, DIMENSION (:,:,:), ALLOCATABLE :: vxold,vyold,vzold

      allocate(pold(nx,ny,nz),STAT=error)
      if(error.ne.0)then
         write(*,*)' failed in allocating array pold in barmatter'
         stop
      endif

      allocate(rhobmold(nx,ny,nz),STAT=error)
      if(error.ne.0)then
         write(*,*)' failed in allocating array rhobmold in barmatter'
         stop
      endif

      allocate(vxold(nx,ny,nz),STAT=error)
      if(error.ne.0)then
         write(*,*)' failed in allocating array vxold in barmatter'
         stop
      endif
      allocate(vyold(nx,ny,nz),STAT=error)
      if(error.ne.0)then
         write(*,*)' failed in allocating array vyold in barmatter'
         stop
      endif
      allocate(vzold(nx,ny,nz),STAT=error)
      if(error.ne.0)then
         write(*,*)' failed in allocating array vzold in barmatter'
         stop
      endif


      pold=(0.0)
      rhobmold=(0.0)
      vxold=(0.0)
      vyold=(0.0)
      vzold=(0.0)

      call searchsave(nes,p,vx,vy,vz,rhobm,
     .     pold,vxold,vyold,vzold,rhobmold,
     .     nx,ny,nz,eta1);


      lstep = mod(nstep,6)+1
      do side=1,3
         SELECT CASE(lflow(side,lstep))
         CASE (0)
            call lx(p,rhobm,vx,vy,vz,
     .           phi,phiold,rhobmold,vxold,nes,
     .           nx,ny,nz,gamma,at,
     .           ath,dat,dt,dtold,
     .           dmax,eta2,norm)

         CASE (1)
            call ly(p,rhobm,vx,vy,vz,
     .           phi,phiold,rhobmold,vyold,nes,
     .           nx,ny,nz,gamma,at,
     .           ath,dat,dt,dtold,
     .           dmax,eta2,norm)

         CASE (2)                        
            call lz(p,rhobm,vx,vy,vz,
     .           phi,phiold,rhobmold,vzold,nes,
     .           nx,ny,nz,gamma,at,
     .           ath,dat,dt,dtold,
     .           dmax,eta2,norm)

         END SELECT
      enddo


      call  expandspeed(p,vx,vy,vz,rhobm,
     .     pold,vxold,vyold,vzold,
     .     nx,ny,nz,dt,
     .     dath,ath,gamma,velmax);


      deallocate(pold)
      deallocate(rhobmold)
      deallocate(vxold)
      deallocate(vyold)
      deallocate(vzold)

      END SUBROUTINE barmatter
