!	1) p3d     I/O
!       2) vx3d    I/O
!       3) vy3d    I/O
!       4) vz3d    I/O
!       5) pold3d  I
!       6) vxold   I
!       7) vyold   I
!     8) vzold   I
      
      SUBROUTINE expandspeed(p3d,vx3d,vy3d,vz3d,rho3d,
     .     pold3d,vxold,vyold,vzold,
     .     nx,ny,nz,dt,dath,ath,gamma,velmax)
!     
!     compute the contribution of the expansion on the hydro variables
!     calculate maximum velocity     
!     
      IMPLICIT NONE
      REAL*8, DIMENSION (nx,ny,nz):: p3d,vx3d,vy3d,vz3d
      REAL*8, DIMENSION (nx,ny,nz):: pold3d,rho3d
      REAL*8, DIMENSION (nz,ny,nz):: vxold,vyold,vzold
      REAL*8  :: dt,ath,dath,gamma,velmax
      INTEGER :: nx,ny,nz
      
!     
!     parameters
!     
      
!
!     local variables

      logical     ltrace
      parameter ( ltrace = .false. )
!     
      INTEGER :: i,j,k
      REAL*8  :: afact,afact1,afact2,ppp
      REAL*8 :: vmax,vsound
!     

      if ( ltrace ) then
         write(*,*)'EXPAND SPEED START'
         CALL checkreal(p3d,nx,ny,nz,'P    ')
         CALL checkreal(vx3d,nx,ny,nz,'VX   ')
         CALL checkreal(vy3d,nx,ny,nz,'VY   ')
         CALL checkreal(vz3d,nx,ny,nz,'VZ   ')
         CALL checkreal(rho3d,nx,ny,nz,'RHO3D')
         CALL checkreal(pold3d,nx,ny,nz,'pold ')
         CALL checkreal(vxold,nx,ny,nz,'vxold')
         CALL checkreal(vyold,nx,ny,nz,'vyold')
         CALL checkreal(vzold,nx,ny,nz,'vzold')
      endif


      afact=dt*(dath/ath)
      afact1=1.0/(1.0+afact)
      afact2=1.0/(2.0+afact)
!     
      vmax=0.0
!     
      do k=1,nz
         do j=1,ny
            do i=1,nx
               vx3d(i,j,k)=(2.0*vx3d(i,j,k)-afact*vxold(i,j,k))*afact2
               vy3d(i,j,k)=(2.0*vy3d(i,j,k)-afact*vyold(i,j,k))*afact2
               vz3d(i,j,k)=(2.0*vz3d(i,j,k)-afact*vzold(i,j,k))*afact2
               ppp=p3d(i,j,k)
               p3d(i,j,k)=(p3d(i,j,k)-afact*pold3d(i,j,k))*afact1
!     
               if(p3d(i,j,k).le.0.0)then
                  if(ppp.gt.0.0)then
                     p3d(i,j,k)=ppp
                  else
                     p3d(i,j,k)=pold3d(i,j,k)
                  endif
               endif
               
!     speed
               vsound=sqrt(gamma*p3d(i,j,k)/rho3d(i,j,k))
               vmax=max(vmax,abs(vx3d(i,j,k))+vsound,
     &              abs(vy3d(i,j,k))+vsound,
     &              abs(vz3d(i,j,k))+vsound)
               
!     
            enddo
         enddo
      enddo

      velmax=vmax


      if ( ltrace ) then
         write(*,*)'EXPAND SPEED END'
         CALL checkreal(p3d,nx,ny,nz,'P    ')
         CALL checkreal(vx3d,nx,ny,nz,'VX   ')
         CALL checkreal(vy3d,nx,ny,nz,'VY   ')
         CALL checkreal(vz3d,nx,ny,nz,'VZ   ')
         write(*,*)'velmax',velmax
         write(*,*)'afact',afact
      endif

      END SUBROUTINE expandspeed
