      SUBROUTINE initbm(rhodm,rhobm,p,
     &     nx,ny,nz,at,pfact,omega_dm,omega_bm)
!     
!     initial condition for the baryonic matter (except from velocity
!     that is calculated in initvel)
!     


      IMPLICIT NONE

!     
!     parameters
!     
      INTEGER :: nx,ny,nz
      REAL*8, DIMENSION (nx,ny,nz) :: rhobm,rhodm,p
      REAL*8  :: at,pfact,omega_dm, omega_bm

      logical     ltrace
      parameter ( ltrace = .false. )

!     
!     local variables
!     
!     INTEGER i,j,k
      REAL*8 dmfact,rbmfact
!      REAL*8 phih_sum
      
      dmfact = 1/omega_dm
      rbmfact = omega_bm
!     
!     
      rhobm=rhodm*dmfact*rbmfact
      p=pfact*at**(-2)*rhobm


      if ( ltrace ) then
         write(*,*)'INITBM STOP'
         CALL checkreal(rhobm,nx,ny,nz,'RHOBM')
      endif


!     
      END SUBROUTINE initbm
