      SUBROUTINE ldivide(p3d,rho3d,vx3d,vy3d,vz3d,
     .     phi3d,phiold3d,rhoold,vold,nes3d,
     .     nx,ny,nz,dp,drho,dvx,dvy,dvz,
     .     dphi,dphiold,drhoold,dvold,dnes,
     .     dnx,dny,dnz,
     .     nstart,nstop,dir)

!     

      IMPLICIT NONE
!     
!     parameters
!     
      INTEGER :: nx,ny,nz,nstart,nstop,dir
      INTEGER :: dnx,dny,dnz
            
      REAL*8, DIMENSION (nx,ny,nz) :: phi3d,phiold3d
      REAL*8, DIMENSION (nx,ny,nz) :: rho3d,rhoold,vold
      REAL*8, DIMENSION (nx,ny,nz) :: p3d,vx3d,vy3d,vz3d
      INTEGER(1), DIMENSION (nx,ny,nz) :: nes3d
      
      REAL*8, DIMENSION (dnx,dny,dnz) :: dphi,dphiold
      REAL*8, DIMENSION (dnx,dny,dnz) :: drho,drhoold,dvold
      REAL*8, DIMENSION (dnx,dny,dnz) :: dp,dvx,dvy,dvz
      INTEGER(1), DIMENSION (dnx,dny,dnz) :: dnes
      
!     
!       local variables
!     
      
      
      INTEGER :: i,j,k,dk,dj
      
!     
      
      logical     ltrace
      parameter ( ltrace = .false. )
      
      if ( ltrace ) then
         write(*,*)'LXdivide'
         write(*,*)'nstart',nstart
         write(*,*)'nstop',nstop
      endif

      SELECT CASE(dir)
!     Z
      CASE (2)
         dj=1
         do j=nstart,nstop
            do i=1,nx
               do k=1,nz
                  dp(i,dj,k)=p3d(i,j,k)
                  drho(i,dj,k)=rho3d(i,j,k)
                  dvx(i,dj,k)=vx3d(i,j,k)
                  dvy(i,dj,k)=vy3d(i,j,k)
                  dvz(i,dj,k)=vz3d(i,j,k)
                  dphi(i,dj,k)=phi3d(i,j,k)
                  dphiold(i,dj,k)=phiold3d(i,j,k)
                  drhoold(i,dj,k)=rhoold(i,j,k)
                  dvold(i,dj,k)=vold(i,j,k)
                  dnes(i,dj,k)=nes3d(i,j,k)
               enddo
            enddo
            dj=dj+1
         enddo
!     X and Y
      CASE DEFAULT
         dk=1
         do k=nstart,nstop
            do j=1,ny
               do i=1,nx
                  dp(i,j,dk)=p3d(i,j,k)
                  drho(i,j,dk)=rho3d(i,j,k)
                  dvx(i,j,dk)=vx3d(i,j,k)
                  dvy(i,j,dk)=vy3d(i,j,k)
                  dvz(i,j,dk)=vz3d(i,j,k)
                  dphi(i,j,dk)=phi3d(i,j,k)
                  dphiold(i,j,dk)=phiold3d(i,j,k)
                  drhoold(i,j,dk)=rhoold(i,j,k)
                  dvold(i,j,dk)=vold(i,j,k)
                  dnes(i,j,dk)=nes3d(i,j,k)
               enddo
            enddo
            dk=dk+1
         enddo
      END SELECT

        if ( ltrace ) then
           write(*,*)'Ldivide end'
           CALL checkreal(dp,dnx,dny,dnz,'DP    ')
        endif
!     
	END SUBROUTINE ldivide
	
!           write(*,*)'gamma',gamma
!           write(*,*)'dmax',dmax
!           write(*,*)'rgamma',rgamma
!           write(*,*)'gamma1',gamma1
!           write(*,*)'gf',gf
!           write(*,*)'dx',dx
!           write(*,*)'rdx',rdx
!           write(*,*)'rdtath',rdtath
!           write(*,*)'rat',rat
!           write(*,*)'m',m
!           write(*,*)'rm',rm
