      SUBROUTINE lmerge(p3d,rho3d,vx3d,vy3d,vz3d,
     .     nes3d,nx,ny,nz,dp,drho,dvx,dvy,dvz,
     .     dnes,dnx,dny,dnz,nstart,nstop,dir)

!     

      IMPLICIT NONE
!     
!     parameters
!     
      INTEGER :: nx,ny,nz,nstart,nstop,dir
      INTEGER :: dnx,dny,dnz
      
      REAL*8, DIMENSION (nx,ny,nz) :: rho3d
      REAL*8, DIMENSION (nx,ny,nz) :: p3d,vx3d,vy3d,vz3d
      INTEGER(1), DIMENSION (nx,ny,nz) :: nes3d
      
      REAL*8, DIMENSION (dnx,dny,dnz) :: drho
      REAL*8, DIMENSION (dnx,dny,dnz) :: dp,dvx,dvy,dvz
      INTEGER(1), DIMENSION (dnx,dny,dnz) :: dnes
      
!     
!     local variables
!     
      
      
      INTEGER :: i,j,k,dk,dj
      
!     
      
      logical     ltrace
      parameter ( ltrace = .false. )
      

      if ( ltrace ) then
         write(*,*)'Lmerge'
         write(*,*)'nstart',nstart
         write(*,*)'nstop',nstop
      endif
      
      SELECT CASE(dir)
!     Z
      CASE (2)
         dj=1
         do j=nstart,nstop
            do i=1,nx
               do k=1,nz
                  p3d(i,j,k)=dp(i,dj,k)
                  rho3d(i,j,k)=drho(i,dj,k)
                  vx3d(i,j,k)=dvx(i,dj,k)
                  vy3d(i,j,k)=dvy(i,dj,k)
                  vz3d(i,j,k)=dvz(i,dj,k)
                  nes3d(i,j,k)=dnes(i,dj,k)
               enddo
            enddo
            dj=dj+1
         enddo
      CASE DEFAULT
         dk=1
         do k=nstart,nstop
            do j=1,ny
               do i=1,nx
                  p3d(i,j,k)=dp(i,j,dk)
                  rho3d(i,j,k)=drho(i,j,dk)
                  vx3d(i,j,k)=dvx(i,j,dk)
                  vy3d(i,j,k)=dvy(i,j,dk)
                  vz3d(i,j,k)=dvz(i,j,dk)
                  nes3d(i,j,k)=dnes(i,j,dk)
               enddo
            enddo
            dk=dk+1
         enddo
      END SELECT
      
      if ( ltrace ) then
         write(*,*)'Lmerge end'
         CALL checkreal(p3d,nx,ny,nz,'P    ')
!         CALL checkreal(rho3d,nx,ny,nz,'RHO  ')
!         CALL checkreal(vx3d,nx,ny,nz,'VX   ')
!         CALL checkreal(vy3d,nx,ny,nz,'VY   ')
!         CALL checkreal(vz3d,nx,ny,nz,'VZ   ')
!         CALL checkbyte(nes3d,nx,ny,nz,'NES  ')
      endif
!     
      END SUBROUTINE lmerge
	
