!     1) p3d     I/O
!     2) rho3d   I/O
!     3) vx3d    I/O
!     4) vy3d    I/O
!     5) vz3d    I/O
!     6) cho3d   I/O
!     7) phi3d   I
!     8) phiold3d I
!     9) rhoold3d I
!       10)vxold    I
!     11)nes3d    I
      
      SUBROUTINE lx(p3d,rho3d,vx3d,vy3d,vz3d,
     .     phi3d,phiold3d,rhoold,vxold,nes3d,
     .     nx,ny,nz,gamma,at,ath,dat,dt,dtold,
     .     dmax,eta2,norm)
!     
!     integration in the x direction
!     insert ystart ystop zstart zstop

      IMPLICIT NONE
!     
!     parameters
!     
	INTEGER :: nx,ny,nz
	REAL*8 :: dat,dt,gamma,at
	REAL*8 :: dmax,ath,norm
	REAL*8 :: eta2,dtold

	REAL*8, DIMENSION (nx,ny,nz) :: phi3d,phiold3d
	REAL*8, DIMENSION (nx,ny,nz) :: rho3d,rhoold,vxold
	REAL*8, DIMENSION (nx,ny,nz) :: p3d,vx3d,vy3d,vz3d
	INTEGER(1), DIMENSION (nx,ny,nz) :: nes3d


!       
!       local variables
!       

	
	INTEGER(1), DIMENSION(nx) :: nes
!
        REAL*8, DIMENSION(nx) :: pres,rho,vx,vy,g
        REAL*8, DIMENSION(nx) :: vz,c,eint,etot,ghalf
        REAL*8, DIMENSION(nx) :: rhoold1d,vxold1d,phi1,phi0

	REAL*8 :: rgamma,rgamma1,gamma1,gf,dx,rdx,rdtath
        REAL*8 :: rat,rm,m

	INTEGER :: i,j,k
	REAL*8  :: internal,total
!       

        logical     ltrace
        parameter ( ltrace = .false. )



        rgamma = 1.0/gamma
        gamma1=(gamma+1.0)/(gamma-1.0)
        rgamma1=1.0/(gamma-1)
        gf=(gamma+1.0)/(2.0*gamma)
        dx=1.0*norm
        rdx=1.0/dx
        rdtath=dt/ath
        rat = 1.0/at
        m=(gamma-1.0)/(2.0*gamma)
        rm=1.0/m
        
        if ( ltrace ) then
           write(*,*)'LX'
           CALL checkreal(p3d,nx,ny,nz,'P    ')
           CALL checkbyte(nes3d,nx,ny,nz,'NES  ')
        endif

	do k=1,nz
	   do j=1,ny
	      do i=1,nx
		 pres(i)=p3d(i,j,k)
		 rho(i)=rho3d(i,j,k)
		 vx(i)=vx3d(i,j,k)
		 vy(i)=vy3d(i,j,k)
		 vz(i)=vz3d(i,j,k)
		 phi1(i)=phiold3d(i,j,k)
		 phi0(i)=phi3d(i,j,k)
		 rhoold1d(i)=rhoold(i,j,k)
		 vxold1d(i)=vxold(i,j,k)
		 eint(i)=internal(i,pres,rgamma1,nx)
		 etot(i)=total(i,pres,rho,vx,vy,vz,rgamma1,nx)

		 nes(i)=nes3d(i,j,k)
		 c(i)=sqrt(gamma*p3d(i,j,k)/rho3d(i,j,k))
	      enddo
	      call gforce(g,ghalf,phi0,phi1,rho,nx,dt,dtold,rdx)
!       call flattening
	      call ppm(pres,rho,g,vx,vy,vz,c,etot,
     &     eint,ghalf,rhoold1d,vxold1d,nes,nx,
     &     dat,dt,rat,dx,gamma,at,m,rgamma1,gf,gamma1,
     &     rm,rgamma,dmax,rdtath,rdx,eta2)	

	      do i=1,nx
		 p3d(i,j,k)=pres(i)
		 rho3d(i,j,k)=rho(i)
		 vx3d(i,j,k)=vx(i)
		 vy3d(i,j,k)=vy(i)
		 vz3d(i,j,k)=vz(i)
		 nes3d(i,j,k)=nes(i)
	      enddo
	   enddo
	enddo

        if ( ltrace ) then
           write(*,*)'LX end'
           CALL checkreal(p3d,nx,ny,nz,'P    ')
           CALL checkreal(rho3d,nx,ny,nz,'RHO  ')
           CALL checkreal(vx3d,nx,ny,nz,'VX   ')
           CALL checkreal(vy3d,nx,ny,nz,'VY   ')
           CALL checkreal(vz3d,nx,ny,nz,'VZ   ')
           CALL checkbyte(nes3d,nx,ny,nz,'NES  ')
        endif
!       
!           write(*,*)'dmax',dmax
	END SUBROUTINE lx
	
!           write(*,*)'gamma',gamma

!           write(*,*)'rgamma',rgamma
!           write(*,*)'gamma1',gamma1
!           write(*,*)'gf',gf
!           write(*,*)'dx',dx
!           write(*,*)'rdx',rdx
!           write(*,*)'rdtath',rdtath
!           write(*,*)'rat',rat
!           write(*,*)'m',m
!           write(*,*)'rm',rm
