      SUBROUTINE ly(p3d,rho3d,vx3d,vy3d,vz3d,
     .     phi3d,phiold3d,rhoold,vyold,nes3d,
     .     nx,ny,nz,gamma,at,ath,dat,dt,dtold,
     .     dmax,eta2,norm)
!     
!     integration in the y direction
!
        IMPLICIT NONE
!       
!       parameters
!       
	INTEGER :: nx,ny,nz
	REAL*8 :: dat,dt,rat,dx,gamma,at,m,rgamma1
	REAL*8 :: gf,gamma1,rm,rgamma,dmax,rdtath
	REAL*8 :: rdx,eta2,dtold,norm,ath

	REAL*8, DIMENSION (nx,ny,nz) :: phi3d,phiold3d
	REAL*8, DIMENSION (nx,ny,nz) :: rho3d,rhoold,vyold
	REAL*8, DIMENSION (nx,ny,nz) :: p3d,vx3d,vy3d,vz3d
	INTEGER(1), DIMENSION (nx,ny,nz) :: nes3d

        INTEGER(1), DIMENSION(ny) :: nes
!
        REAL*8, DIMENSION(ny) :: pres,rho,vx,vy,g
        REAL*8, DIMENSION(ny) :: vz,c,eint,etot,ghalf
        REAL*8, DIMENSION(ny) :: rhoold1d,vyold1d,phi1,phi0

!     
!     local variables
!     
      INTEGER :: i,j,k
      REAL*8  :: internal,total

      logical     ltrace
      parameter ( ltrace = .false. )

!     
      if ( ltrace ) then
         write(*,*)'LY'
      endif

      rgamma = 1.0/gamma
      gamma1=(gamma+1.0)/(gamma-1.0)
      rgamma1=1.0/(gamma-1)
      gf=(gamma+1.0)/(2.0*gamma)
      dx=1.0*norm
      rdx=1.0/dx
      rdtath=dt/ath
      rat = 1.0/at
      m=(gamma-1.0)/(2.0*gamma)
      rm=1.0/m


      do k=1,nz
         do i=1,nx
	    do j=1,ny
               pres(j)=p3d(i,j,k)
               rho(j)=rho3d(i,j,k)
               vx(j)=vy3d(i,j,k)
               vy(j)=vz3d(i,j,k)
               vz(j)=vx3d(i,j,k)
               phi1(j)=phiold3d(i,j,k)
               phi0(j)=phi3d(i,j,k)
               rhoold1d(j)=rhoold(i,j,k)
               vyold1d(j)=vyold(i,j,k)
               eint(j)=internal(j,pres,rgamma1,ny)
               etot(j)=total(j,pres,rho,vx,vy,vz,rgamma1,ny)
               nes(j)=nes3d(i,j,k)
               c(j)=sqrt(gamma*p3d(i,j,k)/rho3d(i,j,k))
	    enddo

	    call gforce(g,ghalf,phi0,phi1,rho,ny,dt,dtold,rdx)
!     call flattening
            call ppm(pres,rho,g,vx,vy,vz,c,etot,
     &           eint,ghalf,rhoold1d,vyold1d,nes,ny,
     &           dat,dt,rat,dx,gamma,at,m,rgamma1,gf,gamma1,
     &           rm,rgamma,dmax,rdtath,rdx,eta2)
	    do j=1,ny
               p3d(i,j,k)=pres(j)
               rho3d(i,j,k)=rho(j)
               vx3d(i,j,k)=vz(j)
               vy3d(i,j,k)=vx(j)
               vz3d(i,j,k)=vy(j)
               nes3d(i,j,k)=nes(j)
            enddo
	 enddo
      enddo

      if ( ltrace ) then
         write(*,*)'LY end'
           CALL checkreal(p3d,nx,ny,nz,'P    ')
           CALL checkreal(rho3d,nx,ny,nz,'RHO  ')
           CALL checkreal(vx3d,nx,ny,nz,'VX   ')
           CALL checkreal(vy3d,nx,ny,nz,'VY   ')
           CALL checkreal(vz3d,nx,ny,nz,'VZ   ')
           CALL checkbyte(nes3d,nx,ny,nz,'NES  ')
      endif

      END SUBROUTINE ly
      
