      SUBROUTINE lz(p3d,rho3d,vx3d,vy3d,vz3d,
     .     phi3d,phiold3d,rhoold,vzold,nes3d,
     .     nx,ny,nz,gamma,at,ath,dat,dt,dtold,
     .     dmax,eta2,norm)
!     
!     integration along the z direction
!     
      IMPLICIT NONE
!     
!     parameters
!     

      INTEGER :: nx,ny,nz
      REAL*8 :: dat,dt,rat,dx,gamma,at,m,rgamma1
      REAL*8 :: gf,gamma1,rm,rgamma,dmax,rdtath
      REAL*8 :: rdx,eta2,dtold,norm,ath
      
      REAL*8, DIMENSION (nx,ny,nz) :: phi3d,phiold3d
      REAL*8, DIMENSION (nx,ny,nz) :: rho3d,rhoold,vzold
      REAL*8, DIMENSION (nx,ny,nz) :: p3d,vx3d,vy3d,vz3d
      INTEGER(1), DIMENSION (nx,ny,nz) :: nes3d
      

      INTEGER(1), DIMENSION(nz) :: nes
!     
      REAL*8, DIMENSION(nz) :: pres,rho,vx,vy,g
      REAL*8, DIMENSION(nz) :: vz,c,eint,etot,ghalf
      REAL*8, DIMENSION(nz) :: rhoold1d,vzold1d,phi1,phi0
      
      
!     
!     local variables
!     

      INTEGER :: i,j,k
      REAL*8  :: internal,total

      logical     ltrace
      parameter ( ltrace = .false. )

!     
      if ( ltrace ) then
         write(*,*)'LZ'
      endif
      rgamma = 1.0/gamma
      gamma1=(gamma+1.0)/(gamma-1.0)
      rgamma1=1.0/(gamma-1)
      gf=(gamma+1.0)/(2.0*gamma)
      dx=1.0*norm
      rdx=1.0/dx
      rdtath=dt/ath
      rat = 1.0/at
      m=(gamma-1.0)/(2.0*gamma)
      rm=1.0/m



      
      do j=1,ny
         do i=1,nx
            do k=1,nz
               pres(k)=p3d(i,j,k)
               rho(k)=rho3d(i,j,k)
               vx(k)=vz3d(i,j,k)
               vy(k)=vy3d(i,j,k)
               vz(k)=vx3d(i,j,k)
               phi1(k)=phiold3d(i,j,k)
               phi0(k)=phi3d(i,j,k)
               rhoold1d(k)=rhoold(i,j,k)
               vzold1d(k)=vzold(i,j,k)
               eint(k)=internal(k,pres,rgamma1,nz)
               etot(k)=total(k,pres,rho,vx,vy,vz,rgamma1,nz)
               nes(k)=nes3d(i,j,k)
               c(k)=sqrt(gamma*p3d(i,j,k)/rho3d(i,j,k))
	    enddo
!     
            call gforce(g,ghalf,phi0,phi1,rho,nz,dt,dtold,rdx)
!     
            call ppm(pres,rho,g,vx,vy,vz,c,etot,
     &           eint,ghalf,rhoold1d,vzold1d,nes,nz,
     &           dat,dt,rat,dx,gamma,at,m,rgamma1,gf,gamma1,
     &           rm,rgamma,dmax,rdtath,rdx,eta2)


!     
            do k=1,nz    
               p3d(i,j,k)=pres(k)
               rho3d(i,j,k)=rho(k)
               vz3d(i,j,k)=vx(k)
               vy3d(i,j,k)=vy(k)
               vx3d(i,j,k)=vz(k)
               nes3d(i,j,k)=nes(k)
            enddo      
         enddo         
      enddo
!     
!     

      if ( ltrace ) then
         write(*,*)'LZ end'
           CALL checkreal(p3d,nx,ny,nz,'P    ')
           CALL checkreal(rho3d,nx,ny,nz,'RHO  ')
           CALL checkreal(vx3d,nx,ny,nz,'VX   ')
           CALL checkreal(vy3d,nx,ny,nz,'VY   ')
           CALL checkreal(vz3d,nx,ny,nz,'VZ   ')
           CALL checkbyte(nes3d,nx,ny,nz,'NES  ')
      endif
      END SUBROUTINE lz
