C===============================================================
C     
      SUBROUTINE PC3FFT(A,DESCA,ISIGN)
C     

      IMPLICIT NONE

      EXTERNAL FACTOR235

      integer desca(12)
      complex*16 a(desca(8),desca(9),*)
      INTEGER NR1, NR2, NR3, ISIGN

      LOGICAL FIRST
      INTEGER ERR
      REAL*8  FAC, SCALE, T1, T2
      COMPLEX*16, allocatable ::  B(:,:,:)
      COMPLEX*16, allocatable ::  Buffer(:)
      integer     inx_start, inx_end
      integer     i, j, k
      integer     ip, ibuf, isour, idest
      integer     nfftx1,nfftx2
      INTEGER     bufsize
      INTEGER     me,nproc

      SAVE FIRST,FAC
      DATA FIRST/.TRUE./

      nr1    = DESCA(1) 
      nr2    = DESCA(2)
      nr3    = DESCA(3)
      nfftx1 = desca(8)
      nfftx2 = desca(9)
      me     = desca(5) + 1
      nproc  = desca(6)

      bufsize = NR2 * NR3/NPROC * NR1/NPROC

      allocate(B(NR3,NR2,NR1/NPROC))
      allocate(Buffer(NR2 * NR3/NPROC * NR1/NPROC))

C...  FFT INIZIALIZATION       
      IF(FIRST) THEN

         FAC=1.D0/DBLE(NR1*NR2*NR3)

C     
C     In this version only dimensions factorizable in power of 2, 3, 5
C     are allowed.
C     
         if(mod(nr1,nproc).ne.0) then
            call error('pc3fft','nr1/nproc',nr1)
         end if
         if(mod(nr2,nproc).ne.0) then
            call error('pc3fft','nr2/nproc',nr2)
         end if
         if(mod(nr3,nproc).ne.0) then
            call error('pc3fft','nr3/nproc',nr3)
         end if

         CALL FACTOR235(NR1,err)
         if(err.ne.0) then
            call error('pc3fft','nr1',nr1)
         end if
         CALL FACTOR235(NR2,err)
         if(err.ne.0) then
            call error('pc3fft','nr2',nr2)
         end if
         CALL FACTOR235(NR3,err)
         if(err.ne.0) then
            call error('pc3fft','nr3',nr3)
         end if
         
         call  create_plan(nr1,nr2,nr3)

      END IF

      IF(ISIGN.GT.0) THEN
         SCALE = FAC
      ELSE
         SCALE = 1.0d0
      END IF

      call FFT_XY(isign,a(1,1,1),nr1,nr2,nr3/nproc,NFFTX1,NFFTX2)

      DO IP = 1,NPROC
         ISOUR = MOD(ME-IP-1+NPROC,NPROC)+1
         IDEST = MOD(ME+IP-1      ,NPROC)+1
         ibuf = 1
         inx_start = (idest-1) * nr1/nproc + 1
         inx_end   = inx_start + nr1/nproc - 1 
         do i = inx_start , inx_end 
            do j = 1 , nr2 
               do k = 1 , nr3/nproc 
                  buffer(ibuf) = a(i,j,k)
                  ibuf = ibuf + 1
               end do
            end do
         end do
         ibuf = 1
         inx_start = (isour-1) * nr3/nproc + 1 
         inx_end   = inx_start + nr3/nproc - 1
         do k = 1 , nr1/nproc   
            do j = 1 , nr2 
               do i = inx_start , inx_end 
                  b(i,j,k) = buffer(ibuf) 
                  ibuf = ibuf + 1
               end do
            end do
         end do
      end do

      call FFT_Z(isign,b(1,1,1), nr3, nr2, nr1/nproc, nr3, nr2)

      DO IP = 1,NPROC
         ISOUR = MOD(ME-IP-1+NPROC,NPROC)+1
         IDEST = MOD(ME+IP-1      ,NPROC)+1
         ibuf = 1
         inx_start = (idest-1) * nr3/nproc + 1
         inx_end   = inx_start + nr3/nproc - 1 
         do k = 1 , nr1/nproc 
            do j = 1 , nr2 
               do i = inx_start , inx_end 
                  buffer(ibuf) = b(i,j,k)
                  ibuf = ibuf + 1
               end do
            end do
         end do
         ibuf = 1
         inx_start = (isour-1) * nr1/nproc + 1 
         inx_end   = inx_start + nr1/nproc - 1
         do i = inx_start , inx_end   
            do j = 1 , nr2 
               do k = 1 , nr3/nproc 
                  a(i,j,k) = buffer(ibuf) * scale
                  ibuf = ibuf + 1
               end do
            end do
         end do
      end do

      if(first) then
         first = .false.
      end if

      deallocate(B)
      deallocate(Buffer)

      RETURN
      END
