      SUBROUTINE fields(phi3d,phiold,rhodm3d,rhobm3d,
     &     grav_shap,gx,gy,gz,gxold,gyold,gzold,
     &     nx,ny,nz,ga,dt,dtold,nstep)
!     

      IMPLICIT NONE

!     
!     parameters
!     

      REAL*8, DIMENSION (nx,ny,nz) :: phi3d,phiold,rhodm3d,rhobm3d
      REAL*8, DIMENSION (nx,ny,nz) :: gx,gy,gz,gxold,gyold,gzold
      REAL*8, DIMENSION (0:nx-1,0:ny-1,0:nz-1) :: grav_shap
      REAL*8  :: ga,dt,dtold
      INTEGER :: nx,ny,nz,nstep



!     
!     local variables
!     

      INTEGER :: iphig
      INTEGER :: error

      COMPLEX*16, DIMENSION (:,:,:), ALLOCATABLE :: A
      REAL*8, DIMENSION(0:nx-1) :: ak,akq

!     

      allocate(A(nx,ny,nz),STAT=error)
      if(error.ne.0)then
         write(*,*)' failed in allocating array A in FIELDS'
         stop
      endif

      A=(0.0,0.0)


!     calculate gravitational potential
!     

      call gravpot(A,phi3d,rhodm3d,rhobm3d,grav_shap,ak,akq,
     .     nx,ny,nz,ga)

!     
!     calculate gravitational forces
!     
      iphig=1
      call gravforce(A,grav_shap,gx,ak,akq,nx,ny,nz,ga,iphig)

      iphig=2
      call gravforce(A,grav_shap,gy,ak,akq,nx,ny,nz,ga,iphig)
      
      iphig=3
      call gravforce(A,grav_shap,gz,ak,akq,nx,ny,nz,ga,iphig)

    
      call gravhalf(phi3d,phiold,gx,gy,gz,gxold,gyold,gzold,
     &     nx,ny,nz,dt,dtold,nstep)

      deallocate(A)
!     
      END SUBROUTINE fields
