#ifndef _DARK_H_
#define _DARK_H_ 1

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/* 
   Include the dark matter methods
 */


/* *********** Methods ********** */

/* Dark matter density */

#define densitydm  FC_FUNC(densitydm,DENSITYDM)
#ifdef __cplusplus
extern "C" {
#endif

  extern void densitydm (double *, float *,float *,float *,
			 int *, int *, int *, int *,double *);

#ifdef __cplusplus
}
#endif

/* Dark matter density using TSC*/

#define densitydmtsc  FC_FUNC(densitydmtsc,DENSITYDMTSC)
#ifdef __cplusplus
extern "C" {
#endif

  extern void densitydmtsc (double *, float *,float *,float *,
			    int *, int *, int *, int *,double *);

#ifdef __cplusplus
}
#endif

/* Move particles */

#define nbody  FC_FUNC(nbody,NBODY)
#ifdef __cplusplus
extern "C" {
#endif

  extern void nbody (float *, float*, float*, float*, float*, float*, 
		     double *, double *,double *, double *, double *,double *,
		     int *, int *, int *, int *,
		     double *, double *,double *, double *, double *,double *);

#ifdef __cplusplus
}
#endif

/* Move particles TSC*/

#define nbodytsc  FC_FUNC(nbodytsc,NBODYTSC)
#ifdef __cplusplus
extern "C" {
#endif

  extern void nbodytsc (float *, float*, float*, float*, float*, float*, 
			double *, double *,double *, double *, double *,double *,
			int *, int *, int *, int *,
			double *, double *,double *, double *, double *,double *);

#ifdef __cplusplus
}
#endif


#define darkmatter  FC_FUNC(darkmatter,DARKMATTER)
#ifdef __cplusplus
extern "C" {
#endif

  extern void darkmatter (float *, float*, float*, float*, float*, float*, 
			  double *, double *,double *, double *, double *,double *,
			  double *,  int *, int *, int *, int *,
			  double *, double *,double *, double *, double *,double *,
			  double *);

#ifdef __cplusplus
}
#endif

/* Calculate dark matter component using TSC */

#define darkmattertsc  FC_FUNC(darkmattertsc,DARKMATTERTSC)
#ifdef __cplusplus
extern "C" {
#endif

  extern void darkmattertsc (float *, float*, float*, float*, float*, float*, 
			     double *, double *,double *, double *, double *,double *,
			     double *,  int *, int *, int *, int *,
			     double *, double *,double *, double *, double *,double *,
			     double *);

#ifdef __cplusplus
}
#endif

#endif /* _DARK_H */
