#ifndef _GRAV_H_
#define _GRAV_H_ 1

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "fftw.h"


/* 
   Include the grav matter methods
 */


/* *********** Methods ********** */


/* Grav shape initialisation */

#define initgrav  FC_FUNC(initgrav,INITGRAV)
#ifdef __cplusplus
extern "C" {
#endif

  extern void initgrav (double *, 
			int *, int *, int *);

#ifdef __cplusplus
}
#endif

/* Gravitational potential */

#define gravpot  FC_FUNC(gravpot,GRAVPOT)
#ifdef __cplusplus
extern "C" {
#endif

  extern void gravpot (FFTW_COMPLEX *, double *, double *, 
		       double *, double *, double *, double *,
		       int *, int *, int *, double *);

#ifdef __cplusplus
}
#endif

/* Gravitational force */

#define gravforce  FC_FUNC(gravforce,GRAVFORCE)
#ifdef __cplusplus
extern "C" {
#endif

  extern void gravforce (FFTW_COMPLEX *, double *, double *, 
		       double *, double *, 
		       int *, int *, int *, double *,int *);

#ifdef __cplusplus
}
#endif

/* Extrapolate forces at half time step */

#define gravhalf  FC_FUNC(gravhalf,GRAVHALF)
#ifdef __cplusplus
extern "C" {
#endif

  extern void gravhalf (double *, double *, 
			double *, double *, double *, 
			double *, double *, double *, 
			int *, int *, int *, 
			double *,double *,int *);

#ifdef __cplusplus
}
#endif

/* */

#define fields  FC_FUNC(fields,FIELDS)
#ifdef __cplusplus
extern "C" {
#endif

  extern void fields (double *, double *, double *, double *, double *, 
		      double *, double *, double *, double *, double *, double *, 
		      int *, int *, int *, double *,double *,double *,int *);

#ifdef __cplusplus
}
#endif

#endif /* _GRAV_H */
