#ifndef _INIT_H_
#define _INIT_H_ 1

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/* 
   Include the fortran initialization methods
 */


/* *********** Methods ********** */

/* Initialize the dark matter*/

#define initdm  FC_FUNC(initdm,INITDM)
#ifdef __cplusplus
extern "C" {
#endif

  extern void initdm (float *,float *,float *,
		      float *,float *,float *,
		      int *, int *, int *, int *,
		      double *,double *,double *);

#ifdef __cplusplus
}
#endif

/* Use grafic to initialize dm */


#define usegrafic  FC_FUNC(usegrafic,USEGRAFIC)
#ifdef __cplusplus
extern "C" {
#endif
  void usegrafic(float *x1,float *x2,float *x3, float *v1,float *v2,float *v3,
		 int *nx, int *ny, int *nz, int *np, double *t0h0, double *at, double *vfact,
		 double *omega_dm, double *omega_bm, double *omega_v, double *hnow, 
		 double *spectidx, double *sigma_8, char *rseed);
  

#ifdef __cplusplus
}
#endif



#endif /* _INIT_H */
