!     X1 = O
!     X2 = O
!     X3 = O
!     V1 = O
!     V1 = O
!     V1 = O
!     nx = I
!     ny = I
!     nz = I
!     nparmax = I
!     t0h0 = I
!     at = 0

      SUBROUTINE initdm(x1,x2,x3,v1,v2,v3,
     &     nx,ny,nz,nparmax,t0h0,at,vfact)
!     

      IMPLICIT NONE

!     
!     parameters

      REAL, DIMENSION (nparmax) :: x1,x2,x3
      REAL, DIMENSION (nparmax) :: v1,v2,v3
      REAL*8  at,t0h0,vfact
      INTEGER :: nx,ny,nz,nparmax

!     
!     local variables

      logical     ltrace
      parameter ( ltrace = .false. )

!     
      REAL(KIND=4) :: x1r4,x2r4,x3r4,v1r4,v2r4,v3r4
      REAL*8 ::  xmpc
      REAL*8 :: vxmax,vymax,vzmax,vxmin,vymin,vzmin,vxav,vyav,vzav
      INTEGER :: j
      REAL*8 :: xmax, ymax, zmax,rat

!      INTEGER :: irec,npes
!      INTEGER :: to_pe,from_pe
!      INTEGER :: req(12)

!      REAL*8 :: xmpc,vfact
!      
      
      
!     
!     read initial expansion factor
!     

      open(30,file='delta.dat',access='direct',recl=4)
      read(30,rec=1)x1r4
      at=dble(x1r4)
      read(30,rec=2)x1r4
      xmpc=dble(x1r4)
      close(30)

!     
!     read initial positions and displacements
!     
      vxav=0.0
      vyav=0.0
      vzav=0.0

      open(30,file='p3m.dat',access='direct',recl=24)
      do j=1,nparmax
         read(30,rec=j)x1r4,x2r4,x3r4,v1r4,v2r4,v3r4
         x1(j)=x1r4
         x2(j)=x2r4
         x3(j)=x3r4
         v1(j)=real(dble(v1r4)*t0h0)
         v2(j)=real(dble(v2r4)*t0h0)
         v3(j)=real(dble(v3r4)*t0h0)
         vxav=vxav+abs(v1(j))
         vyav=vyav+abs(v2(j))
         vzav=vzav+abs(v3(j))
      enddo
      close(30)
      
      vxav=vxav/float(nparmax)
      vyav=vyav/float(nparmax)
      vzav=vzav/float(nparmax)
!     
      
!     
      xmax = float(nx)
      ymax = float(ny)
      zmax = float(nz)

      do j=1,nparmax
         x1(j)=x1(j)*xmpc
         x2(j)=x2(j)*xmpc
         x3(j)=x3(j)*xmpc
         if (x1(j).lt.0.0) x1(j)=x1(j)+xmax
         if (x1(j).ge.xmax) x1(j)=x1(j)-xmax
         if (x2(j).lt.0.0) x2(j)=x2(j)+ymax
         if (x2(j).ge.ymax) x2(j)=x2(j)-ymax
         if (x3(j).lt.0.0) x3(j)=x3(j)+zmax
         if (x3(j).ge.zmax) x3(j)=x3(j)-zmax
      enddo



      vxmax=maxval(v1)
      vymax=maxval(v2)
      vzmax=maxval(v3)
      vxmin=minval(v1)
      vymin=minval(v2)
      vzmin=minval(v3)


      write(*,*)'INITIALIZE DARK MATTER:'

      write(*,99)'at = ',at
      write(*,99)'xmpc = ',xmpc
      write(*,99)'velocity y (max,min,avrg) = ',vxmax,vxmin,vxav
      write(*,99)'velocity x (max,min,avrg) = ',vymax,vymin,vyav
      write(*,99)'velocity z (max,min,avrg) = ',vzmax,vzmin,vzav


 99   format(1x,a31,3(1x,e11.5))

      rat=1.0/at
      vfact=rat*vfact

      if ( ltrace ) then
         write(*,*)'INITDM END'
         write(*,*)'vfact',vfact
         CALL checkvet(x1,nparmax,'X1   ')
         CALL checkvet(x2,nparmax,'X2   ')
         CALL checkvet(x3,nparmax,'X3   ')
         CALL checkvet(v1,nparmax,'V1   ')
         CALL checkvet(v2,nparmax,'V2   ')
         CALL checkvet(v3,nparmax,'V3   ')
      endif


!     
!     calculate initial dark matter density field
!     normalize velocities from km/sec to code units
!     

      v1=vfact*v1
      v2=vfact*v2
      v3=vfact*v3
 


      END SUBROUTINE initdm
