dnl ------------------------------------------------------
dnl AC_FFTW
dnl ------------------------------------------------------
dnl Check if FFTW is usable and working
dnl if not use the included library (may not work)
dnl AC_SEARCH_LIBS (function, search-libs, [action-if-found], [action-if-not-found], [other-libraries]
dnl AC_CHECK_HEADER (header-file, [action-if-found], [action-if-not-found], [includes = `default-includes'])

AC_DEFUN([ACX_FFTW], [

with_fftw_header=no

AC_CHECK_HEADER([fftw.h],[with_fftw_header=yes],
	[AC_MSG_WARN([Cannot find header (fftw.h), use the one included in the package.])])

if test "x$with_fftw_header" != xyes; then
		
	_fftw_headerdir="$PWD/fftw"	

	CFLAGS="$CFLAGS -I$_fftw_headerdir"
fi

with_fftw_lib=no

AC_CHECK_LIB([fftw], [fftw_create_plan],with_fftw_lib=yes,	
		[AC_MSG_WARN([Cannot find (fftw) library])])


if test "x$with_fftw_lib" != xno; then
	AC_SUBST([fftw_library],["-lfftw"])	
fi

if test "x$with_fftw_lib" != xyes; then


	_fftw_savelibs="$LIBS"	

	_fftw=yes
		
	_fftw_libdir="$PWD/fftw"	
	_fftw_lib="$_fftw_libdir/libfftw.a"
	LIBS="$LIBS $_fftw_lib"

	AC_MSG_CHECKING(if the included fftw works)
	AC_LINK_IFELSE([AC_LANG_PROGRAM([#include "fftw.h"],[])],[AC_MSG_RESULT(yes)],[_fftw="no" 
		AC_MSG_RESULT(no)])

	if test "$_fftw" = "no"; then		
		AC_MSG_ERROR([Cannot use fftw libray, please install it.])
	fi

	AC_SUBST([fftw_library],["$_fftw_lib"])

	LIBS="$_fftw_savelibs"
fi



])


