dnl ----------------------------------------------------------------------
dnl CHECK GRIDSOLVE
dnl ----------------------------------------------------------------------

AC_DEFUN([ACX_GRIDSOLVE], [
AC_PREREQ(2.50) dnl for AC_LANG_CASE



AC_ARG_WITH([gridsolve],
            [AS_HELP_STRING([--without-gridsolve],
              [disable support for GridSolve])],
            [],
            [with_gridsolve=yes])


AC_SUBST([problems_root],["/tmp"])

if test "x$with_gridsolve" != xno; then

	_gs_savelibs=$LIBS
	_gs_saveldflags=$LDFLAGS
	_gs_savecflags=$CFLAGS

	_gs="yes"
	_gs_dir="$GRIDSOLVE_ROOT"	
		

	if test "$_gs_dir" = ""; then  
		_gs="no"
	fi

	if test "$_gs" = "yes"; then		               

		_gs_library="$_gs_dir/lib"
		_gs_include="$_gs_dir/include"
dnl		_gs_smart="$_gs_dir/src/smart_mapper" 			

 		
		CFLAGS="$CFLAGS -I$_gs_include"
		LIBS="$LIBS  -lgridsolve"	
		LDFLAGS="$LDFLAGS -L$_gs_library"

		AC_MSG_CHECKING(for grpc.h)	
	        AC_TRY_COMPILE([#include "grpc.h"],[],[AC_MSG_RESULT(yes)],[ _gs="no" 
			AC_MSG_RESULT(no)])

	fi
	
	if test "$_gs" = "yes"; then	
	
		AC_MSG_CHECKING(for GridSolve library)	
                AC_TRY_LINK([#include "grpc.h"],[grpc_initialize(NULL);],[AC_MSG_RESULT(yes)],[ _gs="no" 
			AC_MSG_RESULT(no)])

	fi

	AC_MSG_CHECKING(for GridSolve)
	if test "$_gs" = "yes"; then	

		AC_MSG_RESULT(yes)			
        	AC_DEFINE(HAVE_GRIDSOLVE,1,[Define if you have the GridSolve library.])		
		AC_SUBST([problems_root],["${GRIDSOLVE_ROOT}/problems"])
	else

		CFLAGS="$_gs_savecflags"
		LIBS="$_gs_savelibs"
		LDFLAGS="$_gs_saveldflags"		
		AC_MSG_RESULT(no)
	fi

fi



AM_CONDITIONAL([USEGRIDSOLVE], [test x$_gs = xyes])


])
