dnl ----------------------------------------------------------------------
dnl CHECK SMARTSOLVE
dnl ----------------------------------------------------------------------

AC_DEFUN([ACX_SMARTSOLVE], [
AC_PREREQ(2.50) dnl for AC_LANG_CASE



AC_ARG_WITH([smartsolve],
            [AS_HELP_STRING([--without-smartsolve],
              [disable support for SmartSolve])],
            [],
            [with_smartsolve=yes])

dnl AC_SUBST([problems_root],["/tmp"])

if test "x$with_smartsolve" != xno; then

	_ss_savelibs=$LIBS
	_ss_saveldflags=$LDFLAGS
	_ss_savecflags=$CFLAGS

	_ss="yes"
	_ss_dir="$GRIDSOLVE_ROOT"	
		

	if test "$_ss_dir" = ""; then  
		_ss="no"
	fi

	if test "$_ss" = "yes"; then		               

		_ss_library="$_ss_dir/src/smart_mapper"
		_gs_library="$_gs_dir/lib"
		_ss_include="$_ss_dir/include"

 		
		CFLAGS="$CFLAGS -I$_ss_include"
		LIBS="$LIBS -lgridsolve -lgssmartmapper "	
		LDFLAGS="$LDFLAGS -L$_ss_library -L$_gs_library"

		AC_MSG_CHECKING(for gs_smart_clib.h)	
	        AC_TRY_COMPILE([#include "gs_smart_clib.h"],[],[AC_MSG_RESULT(yes)],[ _ss="no" 
			AC_MSG_RESULT(no)])

	fi
	
	if test "$_ss" = "yes"; then
	
dnl to change here the function call	

		AC_MSG_CHECKING(for SmartSolve library)	
                AC_TRY_LINK([#include "grpc.h"],[grpc_initialize(NULL);],[AC_MSG_RESULT(yes)],[ _ss="no" 
			AC_MSG_RESULT(no)])

	fi

	AC_MSG_CHECKING(for SmartSolve)
	if test "$_ss" = "yes"; then	

		AC_MSG_RESULT(yes)			
        	AC_DEFINE(HAVE_GRIDSOLVE,1,[Define if you have the GridSolve library.])		
        	AC_DEFINE(HAVE_SMARTSOLVE,1,[Define if you have the SmartSolve library.])		
		AC_SUBST([problems_root],["${GRIDSOLVE_ROOT}/problems"])
	else

		CFLAGS="$_ss_savecflags"
		LIBS="$_ss_savelibs"
		LDFLAGS="$_ss_saveldflags"		
		AC_MSG_RESULT(no)
	fi

fi



AM_CONDITIONAL([USESMARTSOLVE], [test x$_ss = xyes])

])
