      SUBROUTINE checkreal(mat,nx,ny,nz,string)
!     

      IMPLICIT NONE

!     
!     parameters
!
      REAL*8, DIMENSION (nx,ny,nz) :: mat
      INTEGER :: nx,ny,nz
      CHARACTER*5 string

!     local variables
!
      REAL*8 :: sum
      INTEGER :: i,j,k

      sum = 0

      do k=1,nz
         do j=1,ny
            do i=1,nx
               sum = sum + mat(i,j,k)**2
            enddo
         enddo
      enddo
     
      write(*,*)string,sqrt(sum)

      
      END SUBROUTINE checkreal
!     

      SUBROUTINE checkcomp(mat,nx,ny,nz,string)
!     

      IMPLICIT NONE

!     
!     parameters
!
      COMPLEX*16, DIMENSION (nx,ny,nz) :: mat
      INTEGER :: nx,ny,nz
      CHARACTER*5 string

!     local variables
!
      COMPLEX*16 :: sum
      INTEGER :: i,j,k

      sum = dcmplx(0.0D0,0.0D0)

      do k=1,nz
         do j=1,ny
            do i=1,nx
               sum = sum + mat(i,j,k)**2
            enddo
         enddo
      enddo
     
      write(*,*)string,sqrt(sum)

      
      END SUBROUTINE checkcomp
!     
      SUBROUTINE checkbyte(mat,nx,ny,nz,string)
!     

      IMPLICIT NONE

!     
!     parameters
!
      INTEGER(1), DIMENSION (nx,ny,nz) :: mat
      INTEGER :: nx,ny,nz
      CHARACTER*5 string

!     local variables
!
      INTEGER :: sum
      INTEGER :: i,j,k

      sum = 0

      do k=1,nz
         do j=1,ny
            do i=1,nx
               sum = sum + mat(i,j,k)
            enddo
         enddo
      enddo
     
      write(*,*)string,sum

      
      END SUBROUTINE checkbyte
!     


      SUBROUTINE checkvet(mat,nx,string)
!     

      IMPLICIT NONE

!     
!     parameters
!
      REAL*8, DIMENSION (nx) :: mat
      INTEGER :: nx
      CHARACTER*5 string

!     local variables
!
      REAL*8 :: sum
      INTEGER :: i

      sum = 0

      do i=1,nx
         sum = sum + mat(i)**2
      enddo

     
      write(*,*)string,sqrt(sum)

      
      END SUBROUTINE checkvet
!     


      SUBROUTINE checkzhalve(mat,nx,ny,nz,d1,d2,part,string)
!     

      IMPLICIT NONE

!     
!     parameters
!
      REAL*8, DIMENSION (nx,ny,nz) :: mat
      REAL*8, DIMENSION (nx,ny,part) :: d1,d2
      INTEGER :: nx,ny,nz,part
      CHARACTER*5 string

!     local variables
!
      REAL*8 :: sum,sum1,sum2
      INTEGER :: i,j,k

      sum = 0
      do k=1,nz
         do j=1,ny
            do i=1,nx
               sum = sum + mat(i,j,k)**2
            enddo
         enddo
      enddo
     
      write(*,*)'full  :',string,sqrt(sum)
      sum1 = 0
      sum2 = 0
      do k=1,part
         do j=1,ny
            do i=1,nx
               sum1 = sum1 + d1(i,j,k)**2
               sum2 = sum2 + d2(i,j,k)**2
            enddo
         enddo
      enddo

      write(*,*)'halve1:',string,sqrt(sum1+sum2)
      END SUBROUTINE checkzhalve
!     
