#include "global.h"
#include "dark.h"
#include <stdlib.h>
#include <stdio.h>


void dark(global *gb)
{

  if(gb->tsc)
    {				
      /* Compute nbody using TSC */
      ETSTART(gb->etnbody);
      HPCALL(gb,nbodytsc,gb->x1,gb->x2,gb->x3,gb->v1,gb->v2,gb->v3,
	     gb->gx,gb->gy,gb->gz,gb->gxold,gb->gyold,gb->gzold,
	     &gb->nx,&gb->ny,&gb->nz,&gb->nparmax,
	     &gb->at,&gb->dat,&gb->ath,&gb->dath,&gb->dt,&gb->dmvelmax);
      ETSTOP(gb->etnbody);
  
      /* Compute dark matter density */
      
      ETSTART(gb->etdensitydm);
      HPCALL(gb,densitydmtsc,gb->rhodm,gb->x1,gb->x2,gb->x3,
	     &gb->nx,&gb->ny,&gb->nz,&gb->nparmax,&gb->amass);
      ETSTOP(gb->etdensitydm);
    }
  else
    {
      /* Compute nbody using CIC */
      ETSTART(gb->etnbody);
      HPCALL(gb,nbody,gb->x1,gb->x2,gb->x3,gb->v1,gb->v2,gb->v3,
	     gb->gx,gb->gy,gb->gz,gb->gxold,gb->gyold,gb->gzold,
	     &gb->nx,&gb->ny,&gb->nz,&gb->nparmax,
	     &gb->at,&gb->dat,&gb->ath,&gb->dath,&gb->dt,&gb->dmvelmax);
      ETSTOP(gb->etnbody);
  
      /* Compute dark matter density */
      
      ETSTART(gb->etdensitydm);
      HPCALL(gb,densitydm,gb->rhodm,gb->x1,gb->x2,gb->x3,
	     &gb->nx,&gb->ny,&gb->nz,&gb->nparmax,&gb->amass);
      ETSTOP(gb->etdensitydm);      
    }
}



