#include "global.h"
#include "grav.h"
#include <stdlib.h>
#include <stdio.h>


void gravitational(global *gb)
{

  int iphig;
  double ga;


  ga = gb->gconst/gb->at;

  ETSTART(gb->etgravpot);
  HPCALL(gb,gravpot,gb->A,gb->phi,gb->rhodm,gb->rhobm,gb->gshape,
	 gb->ak,gb->akq,&gb->nx,&gb->ny,&gb->nz,&ga);
  ETSTOP(gb->etgravpot);


  iphig = 1;
  ETSTART(gb->etgravforce);
  HPCALL(gb,gravforce,gb->A,gb->gshape,gb->gx,gb->ak,gb->akq,
	 &gb->nx,&gb->ny,&gb->nz,&ga,&iphig);
  ETSTOP(gb->etgravforce);

  iphig = 2;
  ETSTART(gb->etgravforce);
  HPCALL(gb,gravforce,gb->A,gb->gshape,gb->gy,gb->ak,gb->akq,
	 &gb->nx,&gb->ny,&gb->nz,&ga,&iphig);
  ETSTOP(gb->etgravforce);

  iphig = 3;
  ETSTART(gb->etgravforce);
  HPCALL(gb,gravforce,gb->A,gb->gshape,gb->gz,gb->ak,gb->akq,
	 &gb->nx,&gb->ny,&gb->nz,&ga,&iphig);
  ETSTOP(gb->etgravforce);

  ETSTART(gb->etgravhalf);
  HPCALL(gb,gravhalf,gb->phi,gb->phiold,gb->gx,gb->gy,gb->gz,
	 gb->gxold,gb->gyold,gb->gzold,
	 &gb->nx,&gb->ny,&gb->nz,&gb->dt,&gb->dtold,&gb->nsteps);
  ETSTOP(gb->etgravhalf);
}


void gravitational_nonblk(global *gb)
{

  int iphig;
  double ga;

  taskvar tgravforce1;
  taskvar tgravforce2;
  taskvar tgravforce3;

  ga = gb->gconst/gb->at;

  ETSTART(gb->etgravpot);

  blockcall("gravpot",
	    gb->A,gb->phi,gb->rhodm,gb->rhobm,gb->gshape,
	    gb->ak,gb->akq,&gb->nx,&gb->ny,&gb->nz,&ga);
  
  ETSTOP(gb->etgravpot);


  iphig = 1;
  nonblockcall("gravforce",&tgravforce1,
	       gb->A,gb->gshape,gb->gx,gb->ak,gb->akq,
	       &gb->nx,&gb->ny,&gb->nz,&ga,&iphig);



  iphig = 2;

  nonblockcall("gravforce",&tgravforce2,
	       gb->A,gb->gshape,gb->gy,gb->ak,gb->akq,
	       &gb->nx,&gb->ny,&gb->nz,&ga,&iphig);
  

  iphig = 3;
  ETSTART(gb->etgravforce);
  nonblockcall("gravforce",&tgravforce3,
	 gb->A,gb->gshape,gb->gz,gb->ak,gb->akq,
	 &gb->nx,&gb->ny,&gb->nz,&ga,&iphig);



  waitnonblock(&tgravforce1);
  waitnonblock(&tgravforce2);
  waitnonblock(&tgravforce3);
  ETSTOP(gb->etgravforce);


  ETSTART(gb->etgravhalf);
  blockcall("gravhalf",gb->phi,gb->phiold,gb->gx,gb->gy,gb->gz,
	 gb->gxold,gb->gyold,gb->gzold,
	 &gb->nx,&gb->ny,&gb->nz,&gb->dt,&gb->dtold,&gb->nsteps);
  ETSTOP(gb->etgravhalf);
}
