      SUBROUTINE indata(np,nx,ny,nz,box,hnow,
     &     omega_dm,omega_bm,omega_v,tempnow,hfrac,
     &     spectidx,sigma_8,rseed, inputfile,lengthfile)
!     
!     
      IMPLICIT NONE
!     
!     parameters
!     
      INTEGER np,nx,ny,nz,lengthfile
      REAL*8 box,hnow
      REAL*8 omega_dm,omega_bm,omega_v
      REAL*8 tempnow,hfrac
      REAL*8 spectidx,sigma_8
      CHARACTER*10 rseed
      CHARACTER(LEN=lengthfile) inputfile
!     
!     define local variables
!     
      integer iunit
      character*60 :: cosmological_model,owner
      integer ngrid
!     
!     read simulation parameters
!     
      write(*,*)'READ INPUT FILE: ',inputfile
      iunit = 800
      OPEN(iunit,file=inputfile,status='old')
      write(*,*)''
!     
      read(iunit,'(a60)')cosmological_model
      read(iunit,'(a60)')owner
      read(iunit,*)np
      read(iunit,*)ngrid

!     
!     physical parameters
!     
      read(iunit,*)box
      read(iunit,*)hnow
      read(iunit,*)omega_dm
      read(iunit,*)omega_bm
      read(iunit,*)omega_v
      read(iunit,*)tempnow
      read(iunit,*)hfrac
!     
      read(iunit,*)spectidx
      read(iunit,*)sigma_8
      read(iunit,'(a9)')rseed


      nx=ngrid
      ny=ngrid
      nz=ngrid

!     
!     cosmological model parameters
!     
      write(*,*)'COSMOLOGICAL MODEL...',cosmological_model
      write(*,*)'SYMULATION BY........',owner
      write(*,*)''
      write(*,*)'INPUT VALUE:'
      write(*,97)'N particles = ',np
      write(*,97)'M grid side = ',nx
      write(*,99)'Omega tot = ',omega_dm+omega_bm+omega_v
      write(*,99)'Omega DM = ',omega_dm
      write(*,99)'Omega BM = ',omega_bm
      write(*,99)'Omega lambda = ',omega_v
      write(*,99)'Hubble const = ',hnow
      write(*,99)'Box size (Mpc) = ',box     
!
      write(*,99)'Long-wave spectral index = ',spectidx
      write(*,99)'Sigma_8 = ',sigma_8
      write(*,98)'Ramdom seed = ',rseed

 99   format(1x,a31,3(1x,e13.7))
 98   format(1x,a31,3(1x,a9))
 97   format(1x,a31,3(1x,i4))      

      END SUBROUTINE indata
