/* Intitialize global variables */

#include "global.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

void initscalar(global *gb)
{

  assert(g);
  double omega_m, xnow, h_sec, tnow,mh,r,rhonow;
  double omega_a, xsinh;  
  int ifail = 0;
  double pi = 3.1415926;

  omega_m = gb->omega_dm+gb->omega_bm;
  omega_a = (omega_m)-0.3*(omega_m+gb->omega_v)+0.3;
  xsinh   = sqrt(fabs(1.0-omega_a)/omega_a);
  gb->t0h0  = 0.666667 *s11abf(&xsinh,&ifail)/sqrt(fabs(1.0-omega_a));
  
  gb->nsteps = 0;

  /* Grid related variables */
  gb->nparmax = gb->np * gb->np *gb->np;
  gb->ntot = gb->nx * gb->ny *gb->nz;
  gb->norm = 1.0;

  /* Memory related variables */
  gb->memuse = 0;

  gb->x1=gb->x2=gb->x3=gb->v1=gb->v2=gb->v3=NULL;

  /* Density related variables */
  gb->amass = gb->omega_dm*((double)gb->ntot)/((double)gb->nparmax);
  gb->dmax = 2.0e10;

  /* 
     Calculate normalization factors >
     a=1 box size in cm
  */    
  xnow=3.086e24*gb->box/(double)gb->nx;

  /* 
     Hubble constant in 1/sec
  */  

  h_sec=gb->hnow/3.0856e17;

  tnow=gb->t0h0/h_sec;

  mh=1.6605e-24;

  r =  1.380658e-16/mh;

  gb->pfact = r*(tnow/xnow)*(tnow/xnow)*gb->tempnow;
  gb->vfact = 1e5*tnow/xnow;
  


  rhonow=3.0*h_sec*h_sec/(25.13274*6.6726e-8);

  gb->gconst  = 4.0*pi*(6.6726e-8)*rhonow*tnow*tnow;

  /*  Fluid Dynamics variables */
  gb->eta1 = 0.3;
  gb->eta2 = 0.005;
  gb->gamma = 1.66666667;

  /* Speed related variables */

  gb->bmvelmax=0;
  gb->dmvelmax=0;

  /* Control flow variables */
  gb->lflow[0][0] = SLX;
  gb->lflow[0][1] = SLY;
  gb->lflow[0][2] = SLZ;

  gb->lflow[1][0] = SLZ;
  gb->lflow[1][1] = SLY;
  gb->lflow[1][2] = SLX;

  gb->lflow[2][0] = SLY;
  gb->lflow[2][1] = SLZ;
  gb->lflow[2][2] = SLX;
  
  gb->lflow[3][0] = SLX;
  gb->lflow[3][1] = SLZ;
  gb->lflow[3][2] = SLY;

  gb->lflow[4][0] = SLZ;
  gb->lflow[4][1] = SLX;
  gb->lflow[4][2] = SLY;

  gb->lflow[5][0] = SLY;
  gb->lflow[5][1] = SLX;
  gb->lflow[5][2] = SLZ;



}
