/* Intitialize time variables */

#include "global.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

void inittime(global *gb)
{

  assert(g);


  double omega_m = gb->omega_dm+gb->omega_bm;
  double dth,th;

  /* Approximate initial time by a flat model */

  gb->told  = pow(gb->at,1.5);
  gb->dt    = 0.010*gb->told;
  gb->dtold = gb->dt;
  gb->t     = gb->told+gb->dt;

  gb->dat   = derivs(&gb->at,&gb->t0h0,&omega_m,&gb->omega_v);

  dth       = 0.5*gb->dt;
  th        = gb->told+dth;
  
  gb->ath   = rk4(&gb->at,&gb->dat,&gb->told,&dth,&gb->t0h0,&omega_m,&gb->omega_v);
  gb->atnew = rk4(&gb->at,&gb->dat,&gb->told,&gb->dt,&gb->t0h0,&omega_m,&gb->omega_v);

  gb->dath  = derivs(&gb->ath,&gb->t0h0,&omega_m,&gb->omega_v);
  gb->datnew= derivs(&gb->atnew,&gb->t0h0,&omega_m,&gb->omega_v);

  /*
  printf("\nTIME VARIABLES:\n");
  printf("at     = %e\n",gb->at);
  printf("dat    = %e\n",gb->dat);
  printf("t      = %e\n",gb->t);
  printf("told   = %e\n",gb->told);
  printf("dt     = %e\n",gb->dt);
  printf("thalf  = %e\n",th);
  printf("atnew  = %e\n",gb->atnew);
  printf("ath    = %e\n",gb->ath);
  printf("datnew = %e\n",gb->datnew);
  printf("dath   = %e\n",gb->dath);
  printf("-------------\n\n");
  */
}
