!     
      SUBROUTINE timeinfo(at,atnew,dat,datnew,ath,dath,
     .     t,told,dt,dtold,t0h0,hnow,nstep)

      IMPLICIT NONE

!
! parameters
!
	
      REAL*8 at,atnew,dat,datnew,ath,dath
      REAL*8 t,told,dt,dtold
      REAL*8 t0h0,hnow
      INTEGER nstep

!     
! local variables
!
      REAL*8, PARAMETER :: year_in_secs=1.0e-6/31536000.0

      REAL*8 :: redshift,redshiftold
      REAL*8 :: hubble
      REAL*8 :: h_sec,tnow
      REAL*8 :: year
!     
! calculate quantities at t^n
!

      h_sec=hnow/3.0856e17
      tnow=t0h0/h_sec

      hubble=at/dat
      redshiftold=1.0/at-1.0
      redshift=1.0/atnew-1.0

      year=told*tnow*year_in_secs
      write(*,*)''
      if( nstep .eq. 0) then
      write(*,97)'******************START*SIMULATION******************'
      write(*,*)''
      endif
      write(*,98)'CALCULATING STEP : ',nstep
      write(*,99)'t_i, t_f, dt : ',told,t,dt
      write(*,99)'a_i, a_f, dat: ',at,atnew,dat
      write(*,99)'z_i, z_f     : ',redshiftold,redshift
      write(*,99)'Hubble const.: ',hubble
      write(*,*)'age of the universe (Myears) : ',year
      write(*,*)''
 97   format(1x,a55)
 98   format(1x,a31,3(1x,i3))
 99   format(1x,a31,3(1x,e13.7))
!
!      write(*,*)'at = ',at
!      write(*,*)'ath = ',ath
!      write(*,*)'atnew = ',atnew
!      write(*,*)'dat = ',dat
!      write(*,*)'dath = ',dath
!      write(*,*)'datnew = ',datnew
!      write(*,*)'t = ',t
!      write(*,*)'told = ',told
!      write(*,*)'dt = ',dt
!      write(*,*)'dtold = ',dtold

        


      END SUBROUTINE timeinfo
